<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title role="heading">Labels
      <q-badge align="top" outline v-if="filtered_labels">
        {{ filtered_labels.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <div>
    <q-virtual-scroll
      :items="filtered_labels" virtual-scroll-slice-size="60" bordered virtual-scroll-item-size="48"
      class="detail--padding scroll_list" role="region" aria-label="lijst labels">
      <template v-slot="{ item, index }">
        <q-item clickable v-ripple
                v-bind:key="index"
                active-class="active"
                class="q-ml-sm"
                :id="'result_' + index"
                :to="{name: 'label_detail',
                    params: {
                      label_id: item.id,
                      link_role: item.link_role,
                      label_text: item.label_text,
                      label_lang: item.lang,}
              }">
          <q-item-section>
            <q-item-label>
              <q-badge :label="item.lang" class="q-mr-sm lang__badge" color="color_list_selected"
                       text-color="white"></q-badge>
              <!--span class="q-mr-md bg-indigo-1 text-weight-bold">{{label.lang}}</span -->
              {{ item.label_text.substr(0, 80) }}
            </q-item-label>
            <q-item-label caption>{{ item.id }}</q-item-label>
          </q-item-section>
        </q-item>
      </template>
    </q-virtual-scroll>
    <q-inner-loading :showing="typeof this.labels=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.labels=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </div>
</template>


<script>

export default {
  name: "LabelList",
  computed: {
    filtered_labels: function () {
      if (this.filter_lang !== 'Alle'
        || this.filter_role !== 'Alle'
        || (this.search_value && typeof (this.search_value) !== 'undefined' && this.search_value.length > 1)) {
        let filtered = this.labels
        if (this.filter_lang !== 'Alle') {
          filtered = filtered.filter(label => label.lang === this.filter_lang)
        }
        if (this.filter_role !== 'Alle') {
          filtered = filtered.filter(label => label.link_role === this.filter_role)
        }
        if (this.search_value && typeof (this.search_value) !== 'undefined' && this.search_value.length > 1) {
          filtered = filtered.filter(label => label.label_text.toLowerCase().includes(this.search_value.toLowerCase()))
        }
        return filtered
      }
      return this.labels
    }
  },
  props: {
    dts_name: String,
    nt_version: String,
    labels: undefined,
    loading: undefined,
    filter_lang: undefined,
    filter_role: undefined,
    search_value: String,
  },
  mounted() {
    this.$nextTick(() => {
      this.scroll_to_active()
    })
  },
  watch: {
    loading: function () {
      if (this.loading === false) {
        this.$nextTick(() => {
          this.scroll_to_active()
        })
      }
    }
  },
  methods: {
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  }
}
</script>

<style scoped lang="scss">
.active,
.active .q-item__label--caption {
  background: $list_selected_bg;
  color: white;
  opacity: 0.9;
}

.active .lang__badge {
  background-color: white !important;
  color: $list_selected_bg !important;
}

.scroll_list {
  overflow-y: auto;
  top: 100px;
  height: calc(100vh - 300px);
}

</style>
